#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_Autolof.cpp 1.7 3/20/98 11:21:09"; 
#endif
#include <stdio.h>
#include <stdlib.h>
#include "sm_util.h"


/*** 
  SM_AutoLoFunction
  This routine handles the interpretation of configuration file entries for
  SMIME lolevel functions and their execution.  A status is returned.
***/
SM_RET_VAL SM_AutoLoFunction(
      char *lpszProg,       // IN, Keyword for test
      char *lpszINConfigFile,/** IN, config file name **/
      CSMIME *pCsmime,         /** IN, valid Logins. **/
      char *lpszINConfigSection,/** IN, section identifying hilevel ops **/
      char *lpszOutFileName,    // IN, file (optional, if necessary)
      long output_flag,  /** IN, print flag options **/
      long verify_flag)  /** IN, verification flag options **/
{
   long status=0;
   int testIndex=-1;        /** index of the test being executed in while().**/
   int sectionFound=0;
   short local_clear = 0;
   short depend_clear = 0;
   
      SME_SETUP("SM_AutoLoFunction");

            /* process buf, label of lolevel function, and config file to 
               execute. */
            if (strcmp(lpszProg, "LO_TestDN") == 0)
            {
               SME(status = SM_CfgCheckDN(  
                   lpszINConfigFile, // should be HEX string
                   output_flag, verify_flag));
            }
            else if (strcmp(lpszProg, "LO_TestISS") == 0)
            {
               SME(status = SM_CfgCheckIss("123456789", // hardcoded test serial #                   
                   lpszINConfigFile, // should be HEX string
                   output_flag, verify_flag));
            }
            else
                printf("NO LO PROCESSING PERFORMED: %s ####################.\n",
                     lpszProg);
   SME_FINISH_CATCH

   return(status);
}

/*** EOF SM_Autolof.cpp ***/
