#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckIss.cpp 1.3 2/18/98 15:44:21"; 
#endif
/* SM_CfgCheckIss.c */
#include <stdio.h>
#include "sm_util.h"


SM_RET_VAL SM_CfgCheckIss(char *pszSerialNo, char *pszDnString, 
      long output_flag, long verify_flag)
{
   //KwValue kwValue;
   SM_RET_VAL ret = SM_NO_ERROR;
   //CSM_ErrorBuf error;
   CSM_IssuerAndSerialNumber *smIss;
   CSM_IssuerAndSerialNumber *smIss2;
   CSM_Buffer *ptmpCSMB = new CSM_Buffer();
   CSM_DN tmpdn;
   CSM_Buffer tmpsn;

   /* fill a CSM_IssuerAndSerialNumber structure */
   if (output_flag == 1)
      printf("SM_CfgCheckIss: filling...\n");

   SM_Hex2Buffer(pszDnString, ptmpCSMB);

   smIss = new CSM_IssuerAndSerialNumber();
   tmpdn = CSM_DN(ptmpCSMB);
   tmpdn.Decode();
   smIss->SetIssuer(tmpdn);

   tmpsn.Set(pszSerialNo, (SM_SIZE_T)(strlen(pszSerialNo)));
   smIss->SetSerialNo(tmpsn);

   smIss2 = new CSM_IssuerAndSerialNumber();
   tmpdn = CSM_DN(ptmpCSMB);
   tmpdn.Decode();
   smIss2->SetIssuer(tmpdn);

   // Not equal test case
   pszSerialNo = "4563";
   // Equal test case
   //pszSerialNo = "123456789";
   tmpsn.Set(pszSerialNo, (SM_SIZE_T)(strlen(pszSerialNo)));
   smIss2->SetSerialNo(tmpsn);

   if (output_flag == 1)
      printf("SM_CfgCheckIss: The 2 IssuerAndSerialNumber structures are:\n");
   if (*smIss == *smIss2)
      printf("EQUAL\n");
   else
      printf("NOT EQUAL\n");



   // free?
   return ret;
}

