#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_snaccMain.cpp 1.3 3/13/98 14:13:45"; 
#endif
//
// RWC; MSP Fortezza test.

#ifdef WIN32
#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#endif

#include <fstream.h>

//#include "sm_vdasnacc.h"
#include "sm_api.h"

long snaccMainTestSetOf(CSM_Buffer  *&asn1_parms);
long errorMainTestException();


//#define TEST_SET_OF
#define TEST_ERROR



long SM_SnaccSetOfTest(
      char *lpszINConfigFile,/** IN, config file name **/
      CSMIME *pCsmime,   /** IN, valid Logins. **/
      long output_flag,  /** IN, print flag options **/
      long verify_flag)  /** IN, verification flag options **/
{

   //Params dss_parms;  // RWC;
   //Dn4 *dn=NULL;
   //Err_info4 err_info;  // RWC;
   CSM_Buffer  *asn1_parms; // RWC;

   
   //if (argc != 2)
   // {
   //     cerr << "Usage: " << argv[0] << " <BER data file name>" << endl;
   //     cerr << "   Decodes the given AnyTestType BER data file" << endl;
   //     cerr << "   and re-encodes it to stdout" << endl;
   //     exit (1);
   // }
#ifdef BOB
    ifstream dataFile;
    // open the data file
    dataFile.open (argv[1]);

    if (!dataFile)
    {
        perror ("ifstream::open");
        exit (1);
    }

    // get size of the data file file
    dataFile.seekg (0, ios::end);
    int dataSize = dataFile.tellg();
    dataFile.seekg (0);

    // read data from file into contiguous block for a buffer
#if HAVE_VARIABLE_SIZED_AUTOMATIC_ARRAYS
    char data[dataSize];
#else
    char *data = new char[dataSize];
    if (!data)
   return 1;
#endif /* HAVE_VARIABLE_SIZED_AUTOMATIC_ARRAYS */
    dataFile.read (data, dataSize);
    dataFile.close();

    //
    // put the BER data read from the file
    // into buffer format, ready for reading from the
    // beginning
    //
    AsnBuf inputBuf;
    inputBuf.InstallData ((char*)data, dataSize);

    size_t decodedLen;
    AnyTestType att;

    if (!att.BDecPdu (inputBuf, decodedLen))
    {
        cerr << "ERROR - Decode routines failed, exiting..." << endl;
        exit (1);
    }

    cerr  << "decodedValue AnyTestType ::= " << att << endl << endl;

    //
    // allocate a new buffer and set up for writing to
    //
    AsnBuf  outputBuf;
#if HAVE_VARIABLE_SIZED_AUTOMATIC_ARRAYS
    char outputData[dataSize + 512];
#else
    char *outputData = new char[dataSize + 512];
    if (!outputData)
   return 1;
#endif /* HAVE_VARIABLE_SIZED_AUTOMATIC_ARRAYS */
    outputBuf.Init (outputData, dataSize+512);
    outputBuf.ResetInWriteRvsMode();

    size_t encodedLen;
    if (!att.BEncPdu (outputBuf, encodedLen))
    {
        cerr << "ERROR - Encode routines failed" << endl;
    }

    // write the BER value to cout
    outputBuf.ResetInReadMode();
    for ( ; encodedLen > 0; encodedLen--)
        cout.put (outputBuf.GetByte());
#endif              // #ifdef BOB

    /**RWC;if (0)
    {
      fill4_parms(&dss_parms, &err_info);
      enc4_parms(&dss_parms, asn1_parms, &err_info);
    }
    else if (0)
    {
        fill4_dn(&dn, &err_info);
        enc4_dn(dn, asn1_parms, 0, &err_info);
    }
    else if (1)
    {
        gencertSNACC(".\\DsaUser1.cfg", asn1_parms);
    }**/
#ifdef TEST_SET_OF
    snaccMainTestSetOf(asn1_parms);
#endif
#ifdef TEST_ERROR
    errorMainTestException();
#endif

    if (asn1_parms->Length())
    {
      ofstream dataFile;
      // open the data file
      dataFile.open ("c:\\tmp\\dssparms.out", ios::out|ios::binary);

      if (!dataFile)
      {
        perror ("ifstream::open");
        exit (1);
      }
      dataFile.write ((char *)*asn1_parms, asn1_parms->Length());
      dataFile.close();
    }

    return 0;
}

//#undef PrintableString
#ifdef TEST_SET_OF
#include "testSetOf.h"
#include "asn-useful.h"
long snaccMainTestSetOf(CSM_Buffer  *&asn1_parms)
{
    long status=0;
    TestSetOfType tso;
    TestSetOfType tmpTso;
    PrintableString *pTmpPS;
    char *msg[5]={"test 3", "test 1", "test 2dfdf", "test 2", "test 4"};
    char *msg2[5]={"ptest 3", "ptest 1", "ptest 2dfdf", "ptest 2", "ptest 4"};
    int i;
    char tmpBits[4];

    for (i=0; i < 5; i++)
    {
      pTmpPS = tso.testSequenceOf.Append();
      pTmpPS->Set(msg[i]);
    }
    for (i=0; i < 5; i++)
    {
      pTmpPS = tso.testSetOf.Append();
      pTmpPS->Set(msg[i]);
    }

    //tso.boolTrue = new AsnBool(FALSE);
    //tso.boolFalse = new AsnBool(TRUE);

    tmpBits[0] = (char)0xff;
    tmpBits[1] = (char)0xff;
    tmpBits[2] = (char)0xff;
    tmpBits[3] = (char)0xff;
    tso.bitString.Set((const char *)&tmpBits[0], 22);
    tso.bitString.ClrBit(2);
    tso.bitString.ClrBit(15);

    /** Load testSet element. **/
    tso.testSet = new TestSetOfTypeSet();
    tso.testSet->pinteger = 22;
    tso.testSet->pintegerSecond = 24;
    tso.testSet->pprintableString.Set("This is a test of pprintableString.");
    
    for (i=0; i < 5; i++)
    {
      pTmpPS = tso.testSet->ptestPartSeqOf.Append();
      pTmpPS->Set(msg2[i]);
    }

    ENCODE_BUF((&tso), asn1_parms);
    //SNACC_BUFRESET((&tso));
    DECODE_BUF((&tmpTso), asn1_parms);

    printf("snaccMain: snaccMainTestSetOf: boolFalse=%x.\n", tso.boolFalse);
    printf("snaccMain: snaccMainTestSetOf: boolTrue=%x.\n", tso.boolTrue);
    printf("snaccMain: snaccMainTestSetOf: intVar=%d\n", tso.intVar);

    return(status);
}
#endif


#ifdef TEST_ERROR
long errorTestException(long test);
long errorTestException2();
long errorTestException3();
long errorMainTestException()
{
    long status=0;

    SME_SETUP("errorMainTestException");

    //SME(errorTestException(1));
    //SME(errorTestException(2));
    SME(errorTestException(3));

    SME_FINISH_CATCH_APP


    return(status);

}

long errorTestException(long test)
{
    long status=0;
    char *lpszBlob=NULL;


    
    // FIRST USAGE of the error handling functionality.
    SME_SETUP("errorTestException");

    // Perform some processing that directly, locally causes a failure 
    //  (exception).
    printf("errorTestException: before test(%d)==1 check.\n", test);
    if (test == 1)      // THEN cause local ERROR
    {
        SME_THROW(22, "THIS IS A LOCAL ERROR IN errorTestException!,", NULL);
    }

    printf("errorTestException: before test(%d)==2 check.\n", test);
    if (test == 2)      // THEN cause nested ERROR
    {
        SME(errorTestException2());
    }

    printf("errorTestException: before test(%d)==3 check.\n", test);
    if (test == 3)      // THEN cause local ERROR
    {
        SME(printf("errorTestException: before errorTestException3.\n"))
        SME(errorTestException3());
        SME(printf("errorTestException: after errorTestException3.\n"))
    }

    SME_FINISH_CATCH

    return(status);
}


// This function demonstrates the custom developer cleanup in the
// exception handler catch logic.
long errorTestException2()
{
    long status=0;
    char *lpszBlob=NULL;


    SME_SETUP("errorTestException2");

    // Perform some processing that directly, locally causes a failure 
    //  (exception).
    printf("errorTestException2: before exception.\n");
    lpszBlob = (char *)malloc(111);
    SME_THROW(32, "THIS IS A LOCAL ERROR IN errorTestException2!,", NULL);
    printf("errorTestException2: after exception.\n");


    SME_FINISH
    SME_CATCH_SETUP
        // local cleanup logic
        if (lpszBlob) free(lpszBlob);
        // ...
    SME_CATCH_FINISH

    return(status);
}

// This function demonstrates the custom developer cleanup in the
// exception handler catch logic, doubly nested.
long errorTestException3()
{
    long status=0;
    char *lpszBlob=NULL;
    static long repeat_count=0;


    SME_SETUP("errorTestException3");

    if (repeat_count++ < 3)         // NEST 3 TIMES to test recursive exception
    {
        SME(errorTestException3());
    }
    else
    {
        // Perform some processing that directly, locally causes a failure 
        //  (exception).
        SME(printf("errorTestException3: before exception.\n"));
        lpszBlob = (char *)malloc(111);
        SME_THROW(42, "THIS IS A LOCAL ERROR IN errorTestException3!,", NULL);
        SME(printf("errorTestException3: after exception.\n"));
    }


    SME_FINISH
    SME_CATCH_SETUP
        // local cleanup logic
        if (lpszBlob) free(lpszBlob);
        // ...
    SME_CATCH_FINISH

    return(status);
}




#endif



// EOF snaccMain.cpp
